import { Component, Children, cloneElement, createElement } from 'react';
import { Base, markType, EventArgs, ElevationHelper, NativeUI, AnimationKeyFrameEffect, KeyFrameAnimationFactory, runOn, BaseDOMEventProxy, BrushUtil, stringEmpty, PropertyChangedEventArgs, AnimationKeyFrameProperty, TranslateTransform, AnimationKeyFrameEffectTiming, INotifyPropertyChanged_$type, NamePatcher, PortalManager, ReactRenderer, getModifiedProps, isValidProp, brushToString, stringToBrush, ensureBool, toSpinal, initializePropertiesFromCss, delegateRemove, delegateCombine, TypeRegistrar, ValueType, markStruct, StringBuilder, Size, stringFormat, Rect, List$1, truncate, AppearanceHelper, toRect, IgrChildContentModule, markEnum } from 'igniteui-react-core';

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpansionPanelUtilities = /*@__PURE__*/ (() => {
    class ExpansionPanelUtilities extends Base {
        static a(a) {
            let b = a.getNativeElement();
            return b.checked;
        }
        static b(a, b) {
            let c = a.getNativeElement();
            c.checked = b;
        }
        static c(a) {
            let b = 0;
            if (a.altKey) {
                b |= 1;
            }
            if (a.shiftKey) {
                b |= 4;
            }
            if (a.ctrlKey) {
                b |= 2;
            }
            return b;
        }
    }
    ExpansionPanelUtilities.$t = /*@__PURE__*/ markType(ExpansionPanelUtilities, 'ExpansionPanelUtilities');
    return ExpansionPanelUtilities;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnCollapsedEventArgs = /*@__PURE__*/ (() => {
    class OnCollapsedEventArgs extends EventArgs {
    }
    OnCollapsedEventArgs.$t = /*@__PURE__*/ markType(OnCollapsedEventArgs, 'OnCollapsedEventArgs', EventArgs.$);
    return OnCollapsedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnExpandedEventArgs = /*@__PURE__*/ (() => {
    class OnExpandedEventArgs extends EventArgs {
    }
    OnExpandedEventArgs.$t = /*@__PURE__*/ markType(OnExpandedEventArgs, 'OnExpandedEventArgs', EventArgs.$);
    return OnExpandedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ExpansionPanelView = /*@__PURE__*/ (() => {
    class ExpansionPanelView extends Base {
        constructor() {
            super(...arguments);
            this.i = null;
            this.p = null;
            this.g = null;
            this.f = null;
            this.o = null;
            this.k = null;
            this.n = null;
            this.m = null;
            this.l = null;
        }
        get q() {
            return this.p;
        }
        get h() {
            return this.g;
        }
        get j() {
            return this.i;
        }
        ab() {
            this.q.setStyleProperty("display", "flex");
            this.q.setStyleProperty("flexDirection", "column");
            this.q.setStyleProperty("flexWrap", "no-wrap");
            this.q.setStyleProperty("alignItems", "left");
        }
        aj() {
            let a = this.h;
            let b = ElevationHelper.e(a.q, a.bn, a.bm, a.bi);
            this.q.setStyleProperty("box-shadow", b);
        }
        ak() {
            if (null == this.q) {
                return;
            }
            this.aj();
            this.ah();
            this.ai();
            this.ag();
            if (null != this.o) {
                NativeUI.j(this.o, this.h.bl);
            }
            if (null != this.k) {
                NativeUI.n(this.k, this.h.bj);
            }
            if (null != this.n) {
                NativeUI.n(this.n, this.h.bk);
            }
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.k, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.o, 0, null, a);
        }
        d(a) {
            return new AnimationKeyFrameEffect(0, this.l, 0, null, a);
        }
        e(a) {
            return new AnimationKeyFrameEffect(0, this.m, 0, null, a);
        }
        u() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.j;
            }
        }
        r() {
            return this.l.outerHeight();
        }
        ac(a) {
            if (a == null) {
                this.i = null;
                return;
            }
            this.i = a;
            let b = a.rootWrapper;
            this.y(b);
        }
        ag() {
            if (null == this.f) {
                return;
            }
            let a = this.h.n;
            if (a) {
                this.f.svgPath = ExpansionPanelView.s;
            }
            else {
                this.f.svgPath = ExpansionPanelView.t;
            }
        }
        ah() {
            if (null != this.k) {
                let a = this.h.ab;
                this.k.setRawText(a);
            }
        }
        ai() {
            if (null != this.n) {
                let a = this.h.ah;
                this.n.setRawText(a);
            }
        }
        y(a) {
            this.p = a;
            this.ab();
        }
        z(a) {
            this.g = a;
        }
        aa() {
        }
        af(a) {
            let b = this.j;
            this.o = a;
            let c = b.createElement("div");
            this.o.append(c);
            this.v(c);
            let d = b.createElement("div");
            d.setStyleProperty("display", "flex");
            d.setStyleProperty("flex-direction", "column");
            d.setStyleProperty("justify-content", "space-evenly");
            d.setStyleProperty("align-items", "flex-start");
            this.o.append(d);
            let e = b.createElement("div");
            d.append(e);
            this.k = b.createElement("label");
            e.append(this.k);
            let f = b.createElement("div");
            d.append(f);
            this.n = b.createElement("label");
            f.append(this.n);
            this.o.setAttribute("tabindex", "0");
            this.o.setStyleProperty("display", "flex");
            this.o.setStyleProperty("flex-direction", "row");
            c.setStyleProperty("display", "flex");
            c.setStyleProperty("justify-content", "center");
            c.setStyleProperty("flex-direction", "column");
            c.setStyleProperty("margin", "0px 10px 0px 10px");
            c.setStyleProperty("flex", "none | 0 | content");
            this.ak();
            this.o.listen("click", runOn(this, this.w));
            this.o.listen("keydown", runOn(this, this.x));
        }
        v(a) {
            if (this.f != null) {
                return;
            }
            this.i.getPortal(a, "Icon", (b) => {
                let c = b.componentRef;
                this.f = (c.i);
                this.f.fill = ExpansionPanelView.al;
                this.ag();
            }, false);
        }
        ae(a) {
            let b = this.j;
            this.m = a;
            this.m.setAttribute("tabindex", "1");
            this.m.setStyleProperty("overflow", "hidden");
        }
        ad(a) {
            let b = this.j;
            this.l = a;
        }
        w(a) {
            let b = a.originalEvent;
            let c = b.target;
            this.h.a2();
        }
        x(a) {
            let b = BaseDOMEventProxy.cv(a);
            let c = ExpansionPanelUtilities.c(a);
            switch (b) {
                case 9:
                case 3:
                    this.h.a2();
                    a.preventDefault();
                    break;
                case 17:
                    if (c == 1) {
                        this.h.au();
                        a.preventDefault();
                    }
                    break;
                case 15:
                    if (c == 1) {
                        this.h.ar();
                        a.preventDefault();
                    }
                    break;
            }
        }
    }
    ExpansionPanelView.$t = /*@__PURE__*/ markType(ExpansionPanelView, 'ExpansionPanelView');
    ExpansionPanelView.al = /*@__PURE__*/ BrushUtil.g(255, 33, 150, 243);
    ExpansionPanelView.t = "M16.59 8.59L12 13.17 7.41 8.59 6 10l6 6 6-6z";
    ExpansionPanelView.s = "M12 8l-6 6 1.41 1.41L12 10.83l4.59 4.58L18 14z";
    return ExpansionPanelView;
})();
/**
 * @hidden
 */
let ExpansionPanel = /*@__PURE__*/ (() => {
    class ExpansionPanel extends Base {
        constructor() {
            super();
            this.c = null;
            this.onCollapsed = null;
            this.onExpanded = null;
            this.propertyChanged = null;
            this.g = null;
            this.aa = "Caption";
            this.bb = null;
            this.a4 = ExpansionPanel.bs;
            this.a9 = null;
            this.ba = null;
            this.ag = stringEmpty();
            this.be = null;
            this.a5 = ExpansionPanel.bt;
            this.bc = null;
            this.bd = null;
            this.p = -1;
            this.o = ExpansionPanel.r;
            this.m = true;
            this.bf = null;
            this.a6 = ExpansionPanel.bu;
            this.bg = null;
            this.bh = null;
            this.a8 = ExpansionPanel.bw;
            this.a7 = ExpansionPanel.bv;
            this.a3 = ExpansionPanel.br;
            let a = this.f();
            this.g = a;
            a.z(this);
        }
        aw(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.ax(a, b, c);
        }
        get ab() {
            return this.aa;
        }
        set ab(a) {
            if (a == this.aa) {
                return;
            }
            let b = this.aa;
            this.aa = a;
            this.aw("Caption", b, this.aa);
        }
        get bq() {
            return this.bb;
        }
        set bq(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.aw("CaptionTextColor", b, a);
            }
        }
        get bj() {
            return this.a4;
        }
        set bj(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.aw("ActualCaptionTextColor", b, a);
            }
        }
        get bo() {
            return this.a9;
        }
        set bo(a) {
            let b = this.a9;
            this.a9 = a;
            if (b != this.a9) {
                this.aw("CaptionCollapsedTextColor", b, a);
            }
        }
        get bp() {
            return this.ba;
        }
        set bp(a) {
            let b = this.ba;
            this.ba = a;
            if (b != this.ba) {
                this.aw("CaptionExpandedTextColor", b, a);
            }
        }
        get ah() {
            return this.ag;
        }
        set ah(a) {
            if (a == this.ag) {
                return;
            }
            let b = this.ag;
            this.ag = a;
            this.aw("Description", b, this.ag);
        }
        get bz() {
            return this.be;
        }
        set bz(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.aw("DescriptionTextColor", b, a);
            }
        }
        get bk() {
            return this.a5;
        }
        set bk(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.aw("ActualDescriptionTextColor", b, a);
            }
        }
        get bx() {
            return this.bc;
        }
        set bx(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.aw("DescriptionCollapsedTextColor", b, a);
            }
        }
        get by() {
            return this.bd;
        }
        set by(a) {
            let b = this.bd;
            this.bd = a;
            if (b != this.bd) {
                this.aw("DescriptionExpandedTextColor", b, a);
            }
        }
        get s() {
            return this.p;
        }
        set s(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.aw("Elevation", b, a);
            }
        }
        get q() {
            return this.o;
        }
        set q(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.aw("ActualElevation", b, a);
            }
        }
        get n() {
            return this.m;
        }
        set n(a) {
            if (a == this.m) {
                return;
            }
            this.at();
            let b = this.m;
            this.m = a;
            let c = this.h(this.m);
            let d = this.i(this.m);
            let e = this.j(this.m);
            let f = this.k(this.m);
            let g = this.l(this.m);
            c.play();
            d.play();
            e.play();
            f.play();
            g.play();
            c.finished.f((h) => c.commitStyles());
            d.finished.f((h) => d.commitStyles());
            e.finished.f((h) => e.commitStyles());
            f.finished.f((h) => f.commitStyles());
            g.finished.f((h) => {
                g.commitStyles();
                this.aw("Expanded", b, this.m);
                if (this.m) {
                    if (this.onExpanded != null) {
                        this.onExpanded(this, new OnExpandedEventArgs());
                    }
                    else if (this.onCollapsed != null) {
                        this.onCollapsed(this, new OnCollapsedEventArgs());
                    }
                }
            });
        }
        get b6() {
            return this.bf;
        }
        set b6(a) {
            let b = this.bf;
            this.bf = a;
            if (b != this.bf) {
                this.aw("HeaderBackgroundColor", b, a);
            }
        }
        get bl() {
            return this.a6;
        }
        set bl(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.aw("ActualHeaderBackgroundColor", b, a);
            }
        }
        get b7() {
            return this.bg;
        }
        set b7(a) {
            let b = this.bg;
            this.bg = a;
            if (b != this.bg) {
                this.aw("HeaderCollapsedBackgroundColor", b, a);
            }
        }
        get b8() {
            return this.bh;
        }
        set b8(a) {
            let b = this.bh;
            this.bh = a;
            if (b != this.bh) {
                this.aw("HeaderExpandedBackgroundColor", b, a);
            }
        }
        get bn() {
            return this.a8;
        }
        set bn(a) {
            let b = this.a8;
            this.a8 = a;
            if (b != this.a8) {
                this.aw("ActualUmbraShadowColor", b, a);
            }
        }
        get bm() {
            return this.a7;
        }
        set bm(a) {
            let b = this.a7;
            this.a7 = a;
            if (b != this.a7) {
                this.aw("ActualPenumbraShadowColor", b, a);
            }
        }
        get bi() {
            return this.a3;
        }
        set bi(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.aw("ActualAmbientShadowColor", b, a);
            }
        }
        f() {
            return new ExpansionPanelView();
        }
        ax(a, b, c) {
            switch (a) {
                case "CaptionTextColor":
                case "CaptionExpandedTextColor":
                case "CaptionCollapsedTextColor":
                case "DescriptionTextColor":
                case "DescriptionExpandedTextColor":
                case "DescriptionCollapsedTextColor":
                case "HeaderBackgroundColor":
                case "HeaderCollapsedBackgroundColor":
                case "HeaderExpandedBackgroundColor":
                case "Expanded":
                    let d = this.bl;
                    let e = this.b4();
                    let f = this.bj;
                    let g = this.b0();
                    let h = this.bk;
                    let i = this.b2();
                    let j = (d != e) || (f != g) || (h != i);
                    if (j) {
                        this.bl = e;
                        this.bj = g;
                        this.bk = i;
                    }
                    else if (a == "Expanded") {
                        this.g.ak();
                    }
                    break;
                case "Elevation":
                    this.q = this.s == -1 ? ExpansionPanel.r : this.s;
                    break;
                case "ActualElevation":
                case "ActualHeaderBackgroundColor":
                case "ActualCaptionTextColor":
                case "ActualDescriptionTextColor":
                case "ActualUmbraShadowColor":
                case "ActualPenumbraShadowColor":
                case "ActualAmbientShadowColor":
                case "Caption":
                case "Description":
                    this.g.ak();
                    break;
            }
        }
        h(a) {
            let b = this.bj;
            let c = this.b1(a);
            let d = a ? this.b() : this.a();
            let e = this.g.a(d);
            let f = [new AnimationKeyFrameProperty(7, b)];
            let g = [new AnimationKeyFrameProperty(7, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        i(a) {
            let b = this.bk;
            let c = this.b3(a);
            let d = a ? this.b() : this.a();
            let e = this.g.b(d);
            let f = [new AnimationKeyFrameProperty(7, b)];
            let g = [new AnimationKeyFrameProperty(7, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        j(a) {
            let b = this.bl;
            let c = this.b5(a);
            let d = a ? this.b() : this.a();
            let e = this.g.c(d);
            let f = [new AnimationKeyFrameProperty(2, b)];
            let g = [new AnimationKeyFrameProperty(2, c)];
            e.m(...f);
            e.m(...g);
            return KeyFrameAnimationFactory.f.c(e);
        }
        k(a) {
            let b = this.g.r();
            if (b <= 0) {
                b = 500;
            }
            let c = a ? -b : 0;
            let d = a ? 0 : -b;
            let e = a ? 0 : 1;
            let f = a ? 1 : 0;
            let g = a ? this.b() : this.a();
            let h = new TranslateTransform();
            h.k = c;
            let i = new TranslateTransform();
            i.k = d;
            let j = this.g.d(g);
            let k = [new AnimationKeyFrameProperty(14, h), new AnimationKeyFrameProperty(1, e)];
            let l = [new AnimationKeyFrameProperty(14, i), new AnimationKeyFrameProperty(1, f)];
            j.m(...k);
            j.m(...l);
            return KeyFrameAnimationFactory.f.c(j);
        }
        l(a) {
            let b = this.g.r();
            if (b <= 0) {
                b = 500;
            }
            let c = a ? 0 : b;
            let d = a ? b : 0;
            let e = a ? this.b() : this.a();
            let f = this.g.e(e);
            let g = [new AnimationKeyFrameProperty(10, c)];
            let h = [new AnimationKeyFrameProperty(10, d)];
            f.m(...g);
            f.m(...h);
            return KeyFrameAnimationFactory.f.c(f);
        }
        a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 3;
            return a;
        }
        b() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = 300;
            a.b = 3;
            return a;
        }
        at() {
            this.g.u();
        }
        b0() {
            return this.b1(this.n);
        }
        b1(a) {
            let b;
            let c = null;
            c = a ? this.bp : this.bo;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.bq ? this.bq : ExpansionPanel.bs;
            }
            return b;
        }
        b2() {
            return this.b3(this.n);
        }
        b3(a) {
            let b;
            let c = null;
            c = a ? this.by : this.bx;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.bz ? this.bz : ExpansionPanel.bt;
            }
            return b;
        }
        b4() {
            return this.b5(this.n);
        }
        b5(a) {
            let b;
            let c = null;
            c = a ? this.b8 : this.b7;
            if (null != c) {
                b = c;
            }
            else {
                b = null != this.b6 ? this.b6 : ExpansionPanel.bu;
            }
            return b;
        }
        ar() {
            this.n = false;
        }
        destroy() {
            this.provideRenderer(null);
        }
        au() {
            this.n = true;
        }
        notifySizeChanged() {
        }
        provideHeader(a) {
            this.g.af(a);
        }
        provideContentAreaOuter(a) {
            this.g.ae(a);
        }
        provideContentAreaInner(a) {
            this.g.ad(a);
        }
        provideRenderer(a) {
            this.g.ac(a);
        }
        a2() {
            this.n = !this.n;
        }
    }
    ExpansionPanel.$t = /*@__PURE__*/ markType(ExpansionPanel, 'ExpansionPanel', Base.$, [INotifyPropertyChanged_$type]);
    ExpansionPanel.bs = /*@__PURE__*/ BrushUtil.g(188, 0, 0, 0);
    ExpansionPanel.bt = /*@__PURE__*/ BrushUtil.g(188, 0, 0, 0);
    ExpansionPanel.r = 2;
    ExpansionPanel.bu = /*@__PURE__*/ BrushUtil.g(255, 245, 245, 245);
    ExpansionPanel.bw = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    ExpansionPanel.bv = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    ExpansionPanel.br = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    return ExpansionPanel;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrOnExpandedEventArgs {
    createImplementation() {
        return new OnExpandedEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
}

class IgrOnCollapsedEventArgs {
    createImplementation() {
        return new OnCollapsedEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
}

class IgrExpansionPanel extends Component {
    constructor(props) {
        super(props);
        this._reactRenderer = null;
        this._implementation = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._onCollapsed = null;
        this._onCollapsed_wrapped = null;
        this._onExpanded = null;
        this._onExpanded_wrapped = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._getMainRef = this._getMainRef.bind(this);
        this._getHeaderRef = this._getHeaderRef.bind(this);
        this._getContentAreaOuterRef = this._getContentAreaOuterRef.bind(this);
        this._getContentAreaInnerRef = this._getContentAreaInnerRef.bind(this);
        if (props) {
            this.initializeProperties();
        }
        this._initialized = true;
    }
    set height(value) {
        this._height = value;
        if (this._elRef) {
            this._elRef.style.height = value;
            this.i.notifySizeChanged();
        }
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        if (this._elRef) {
            this._elRef.style.height = value;
            this.i.notifySizeChanged();
        }
    }
    get width() {
        return this._width;
    }
    _getMainRef(ref) {
        this._elRef = ref;
        this.verifyReferences();
    }
    _getHeaderRef(ref) {
        this._headerRef = ref;
        this.verifyReferences();
    }
    _getContentAreaOuterRef(ref) {
        this._contentAreaOuterRef = ref;
        this.verifyReferences();
    }
    _getContentAreaInnerRef(ref) {
        this._contentAreaInnerRef = ref;
        this.verifyReferences();
    }
    verifyReferences() {
        if (this._elRef &&
            this._headerRef &&
            this._contentAreaOuterRef &&
            this._contentAreaInnerRef) {
            this.requestRender = this.requestRender.bind(this);
            this._portalManager = new PortalManager("iconContent", this.requestRender);
            var ren = new ReactRenderer(this._elRef, document, true, {}, this._portalManager);
            // render needs to fire again after the portalManager is created. 
            this.requestRender();
            this._reactRenderer = ren;
            this.i.provideRenderer(this._reactRenderer);
            var headerWrapper = this._reactRenderer.getWrapper(this._headerRef);
            this.i.provideHeader(headerWrapper);
            var contentOuterWrapper = this._reactRenderer.getWrapper(this._contentAreaOuterRef);
            this.i.provideContentAreaOuter(contentOuterWrapper);
            var contentInnerWrapper = this._reactRenderer.getWrapper(this._contentAreaInnerRef);
            this.i.provideContentAreaInner(contentInnerWrapper);
        }
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        Children.forEach(propChildren, (ch) => {
            children.push(cloneElement(ch));
        });
        let divChildren = [];
        let header = createElement("div", {
            key: 'expansionPanelHeaderArea',
            ref: this._getHeaderRef
        });
        let contentInner = createElement("div", {
            key: 'expansionPanelContentAreaInner',
            ref: this._getContentAreaInnerRef,
            children: children,
        });
        let contentOuter = createElement("div", {
            key: 'expansionPanelContentAreaOuter',
            ref: this._getContentAreaOuterRef,
            children: contentInner
        });
        divChildren.push(header);
        divChildren.push(contentOuter);
        if (this._portalManager)
            this._portalManager.onRender(divChildren);
        let div = createElement("div", {
            ref: this._getMainRef,
            className: "ig-expansion-panel igr-expansion-panel",
            children: divChildren
        });
        return div;
    }
    requestRender() {
        if (this._initialized)
            this.setState({});
    }
    shouldComponentUpdate(nextProps, nextState) {
        const mod = getModifiedProps(this.props, nextProps);
        for (const p of Object.keys(mod)) {
            if (isValidProp(this, p)) {
                this[p] = mod[p];
            }
        }
        return true;
    }
    initializeProperties() {
        for (const p of Object.keys(this.props)) {
            if (isValidProp(this, p)) {
                this[p] = this.props[p];
            }
        }
    }
    // supports angular themes or custom properties set in CSS
    updateStyle() {
        this._styling(this._elRef, this);
    }
    componentWillUnmount() {
        this.i.destroy();
        if (this._reactRenderer)
            this._reactRenderer.destroy();
    }
    componentDidMount() {
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this.initializeContent();
    }
    initializeContent() {
        this._styling(this._elRef, this);
        this.updateStyle();
    }
    createImplementation() {
        return new ExpansionPanel();
    }
    get i() {
        return this._implementation;
    }
    /**
 * Gets / sets the caption to display in the header area.
*/
    get caption() {
        return this.i.ab;
    }
    set caption(v) {
        this.i.ab = v;
    }
    /**
     * Gets or sets the color to use for the header caption text.
    */
    get captionTextColor() {
        return brushToString(this.i.bq);
    }
    set captionTextColor(v) {
        this.i.bq = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the actual header caption text.
    */
    get actualCaptionTextColor() {
        return brushToString(this.i.bj);
    }
    set actualCaptionTextColor(v) {
        this.i.bj = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the header caption text when the panel is collapsed.
    */
    get captionCollapsedTextColor() {
        return brushToString(this.i.bo);
    }
    set captionCollapsedTextColor(v) {
        this.i.bo = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the header caption text when the panel is expanded.
    */
    get captionExpandedTextColor() {
        return brushToString(this.i.bp);
    }
    set captionExpandedTextColor(v) {
        this.i.bp = stringToBrush(v);
    }
    /**
     * Gets / sets the description to display in the header area.
    */
    get description() {
        return this.i.ah;
    }
    set description(v) {
        this.i.ah = v;
    }
    /**
     * Gets or sets the color to use for the header description text.
    */
    get descriptionTextColor() {
        return brushToString(this.i.bz);
    }
    set descriptionTextColor(v) {
        this.i.bz = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the actual header description text.
    */
    get actualDescriptionTextColor() {
        return brushToString(this.i.bk);
    }
    set actualDescriptionTextColor(v) {
        this.i.bk = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the header description text when the panel is collapsed.
    */
    get descriptionCollapsedTextColor() {
        return brushToString(this.i.bx);
    }
    set descriptionCollapsedTextColor(v) {
        this.i.bx = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the header description text when the panel is expanded.
    */
    get descriptionExpandedTextColor() {
        return brushToString(this.i.by);
    }
    set descriptionExpandedTextColor(v) {
        this.i.by = stringToBrush(v);
    }
    /**
     * Gets or sets the elevation to use for the button regardless of type.
    */
    get elevation() {
        return this.i.s;
    }
    set elevation(v) {
        this.i.s = +v;
    }
    /**
     * Gets or sets the elevation of the border shadow
    */
    get actualElevation() {
        return this.i.q;
    }
    set actualElevation(v) {
        this.i.q = +v;
    }
    /**
     * Gets / sets the expanded state of the panel.
    */
    get expanded() {
        return this.i.n;
    }
    set expanded(v) {
        this.i.n = ensureBool(v);
    }
    /**
     * Gets or sets the color to use for the background of the header.
    */
    get headerBackgroundColor() {
        return brushToString(this.i.b6);
    }
    set headerBackgroundColor(v) {
        this.i.b6 = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the actual background of the header.
    */
    get actualHeaderBackgroundColor() {
        return brushToString(this.i.bl);
    }
    set actualHeaderBackgroundColor(v) {
        this.i.bl = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    get headerCollapsedBackgroundColor() {
        return brushToString(this.i.b7);
    }
    set headerCollapsedBackgroundColor(v) {
        this.i.b7 = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the background of the header when the panel is expanded.
    */
    get headerExpandedBackgroundColor() {
        return brushToString(this.i.b8);
    }
    set headerExpandedBackgroundColor(v) {
        this.i.b8 = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualUmbraShadowColor() {
        return brushToString(this.i.bn);
    }
    set actualUmbraShadowColor(v) {
        this.i.bn = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualPenumbraShadowColor() {
        return brushToString(this.i.bm);
    }
    set actualPenumbraShadowColor(v) {
        this.i.bm = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualAmbientShadowColor() {
        return brushToString(this.i.bi);
    }
    set actualAmbientShadowColor(v) {
        this.i.bi = stringToBrush(v);
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ExpansionPanel");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Collapses the contents of the expansion panel.

*/
    collapse() {
        this.i.ar();
    }
    /**
     * Expands the contents of the expansion panel.
    
    */
    expand() {
        this.i.au();
    }
    /**
     * Toggles the expanded state of the expansion panel.
    
    */
    toggle() {
        this.i.a2();
    }
    /**
     * Fires when the expansion panel is collapsed.
    */
    get onCollapsed() {
        return this._onCollapsed;
    }
    set onCollapsed(ev) {
        if (this._onCollapsed_wrapped !== null) {
            this.i.onCollapsed = delegateRemove(this.i.onCollapsed, this._onCollapsed_wrapped);
            this._onCollapsed_wrapped = null;
            this._onCollapsed = null;
        }
        this._onCollapsed = ev;
        this._onCollapsed_wrapped = (o, e) => {
            let outerArgs = new IgrOnCollapsedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeOnCollapsed) {
                this.beforeOnCollapsed(this, outerArgs);
            }
            if (this._onCollapsed) {
                this._onCollapsed(this, outerArgs);
            }
        };
        this.i.onCollapsed = delegateCombine(this.i.onCollapsed, this._onCollapsed_wrapped);
    }
    get onExpanded() {
        return this._onExpanded;
    }
    set onExpanded(ev) {
        if (this._onExpanded_wrapped !== null) {
            this.i.onExpanded = delegateRemove(this.i.onExpanded, this._onExpanded_wrapped);
            this._onExpanded_wrapped = null;
            this._onExpanded = null;
        }
        this._onExpanded = ev;
        this._onExpanded_wrapped = (o, e) => {
            let outerArgs = new IgrOnExpandedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeOnExpanded) {
                this.beforeOnExpanded(this, outerArgs);
            }
            if (this._onExpanded) {
                this._onExpanded(this, outerArgs);
            }
        };
        this.i.onExpanded = delegateCombine(this.i.onExpanded, this._onExpanded_wrapped);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrExpansionPanelModule {
    static register() {
        TypeRegistrar.registerCons('IgrExpansionPanel', IgrExpansionPanel);
        TypeRegistrar.registerCons('IgrExpansionPanel', IgrExpansionPanel);
        TypeRegistrar.register('ExpansionPanel', ExpansionPanel.$type);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Popup_OuterAnimationInfo = /*@__PURE__*/ (() => {
    class Popup_OuterAnimationInfo extends ValueType {
        constructor() {
            super();
            this.c = 0;
            this.d = 0;
            this.a = 0;
            this.b = 0;
        }
    }
    Popup_OuterAnimationInfo.$t = /*@__PURE__*/ markStruct(Popup_OuterAnimationInfo, 'Popup_OuterAnimationInfo');
    return Popup_OuterAnimationInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let Popup_InnerAnimationInfo = /*@__PURE__*/ (() => {
    class Popup_InnerAnimationInfo extends ValueType {
        constructor() {
            super();
            this.a = 0;
            this.b = 0;
        }
    }
    Popup_InnerAnimationInfo.$t = /*@__PURE__*/ markStruct(Popup_InnerAnimationInfo, 'Popup_InnerAnimationInfo');
    return Popup_InnerAnimationInfo;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnClosedEventArgs = /*@__PURE__*/ (() => {
    class OnClosedEventArgs extends EventArgs {
    }
    OnClosedEventArgs.$t = /*@__PURE__*/ markType(OnClosedEventArgs, 'OnClosedEventArgs', EventArgs.$);
    return OnClosedEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let OnPopupEventArgs = /*@__PURE__*/ (() => {
    class OnPopupEventArgs extends EventArgs {
    }
    OnPopupEventArgs.$t = /*@__PURE__*/ markType(OnPopupEventArgs, 'OnPopupEventArgs', EventArgs.$);
    return OnPopupEventArgs;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupVisualModelExport = /*@__PURE__*/ (() => {
    class PopupVisualModelExport extends Base {
        constructor() {
            super(...arguments);
            this.e = 0;
            this.d = false;
            this.c = null;
            this.b = null;
            this.a = null;
        }
        f() {
            let a = new StringBuilder(0);
            a.l("{");
            a.l("actualElevation : " + this.e + ", ");
            a.l("isShown : " + this.d + ", ");
            a.l("actualUmbraShadowColor : " + this.c.serialize() + ", ");
            a.l("actualPenumbraShadowColor : " + this.b.serialize() + ", ");
            a.l("actualAmbientShadowColor : " + this.a.serialize() + ", ");
            a.l("}");
            return a.toString();
        }
    }
    PopupVisualModelExport.$t = /*@__PURE__*/ markType(PopupVisualModelExport, 'PopupVisualModelExport');
    return PopupVisualModelExport;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let PopupView = /*@__PURE__*/ (() => {
    class PopupView extends Base {
        constructor() {
            super(...arguments);
            this.k = null;
            this.c = null;
            this.o = null;
            this.n = null;
            this.m = null;
            this.p = null;
            this.f = false;
            this.h = 0;
            this.al = new Size(1, 0, 0);
            this.e = true;
            this.g = false;
        }
        get d() {
            return this.c;
        }
        get l() {
            return this.k;
        }
        ab() {
            this.o.setStyleProperty("height", "0%");
            this.o.setStyleProperty("width", "0%");
            this.n = this.k.createElement("div");
            this.n.setStyleProperty("position", "absolute");
            this.n.setStyleProperty("overflow", "hidden");
            this.n.setStyleProperty("z-index", "10000");
            this.n.setAttribute("key", "popupContentAreaOuter");
            this.m = this.k.createElement("div");
            this.m.setAttribute("key", "popupContentAreaInner");
            this.n.append(this.m);
        }
        ai() {
            let a = this.d;
            let b = ElevationHelper.e(a.w, a.a7, a.a6, a.a5);
            this.n.setStyleProperty("box-shadow", b);
        }
        ah() {
            if (this.d.a8 != null) {
                this.n.setStyleProperty("background-color", this.d.a8._fill);
            }
        }
        aj() {
            if (null == this.o) {
                return;
            }
            this.ai();
            this.ah();
        }
        s() {
            if (null != this.n) {
                this.aj();
                this.n.setStyleProperty("height", "0px");
                let a = this.n.getNativeElement();
                if (false == this.f) {
                    document.body.appendChild(a);
                    this.f = true;
                    if (this.e) {
                        this.z();
                    }
                }
            }
        }
        t(a, b) {
            this.n.setStyleProperty("top", PopupView.q(a.b));
            this.n.setStyleProperty("height", PopupView.r(a.d));
            this.m.setStyleProperty("top", PopupView.r(b.b));
            this.m.setStyleProperty("opacity", "1");
            this.m.setStyleProperty("transform", stringEmpty());
            this.h = 0;
            if (this.g) {
                this.ag();
            }
            return {
                p0: a,
                p1: b
            };
        }
        u(a) {
            this.h = a;
        }
        ae() {
            if (null != this.n && this.f) {
                let a = this.n.getNativeElement();
                document.body.removeChild(a);
                this.f = false;
            }
        }
        v(a) {
            this.m.append(a);
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.m, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
        }
        w() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.l;
            }
        }
        get am() {
            if (this.e) {
                this.z();
            }
            return this.al;
        }
        i(a, b) {
            let c;
            let t1 = b;
            L0: while (true) {
                switch (t1) {
                    case 0:
                    case 1:
                        c = a.left;
                        break;
                    case 2:
                        c = a.right - this.am.width;
                        break;
                    default:
                        t1 = 0;
                        continue L0;
                }
                break;
            }
            return c;
        }
        j(a, b) {
            let c;
            let t1 = b;
            L0: while (true) {
                switch (t1) {
                    case 0:
                    case 1:
                        c = a.bottom;
                        break;
                    case 2:
                        c = a.top - this.am.height;
                        break;
                    default:
                        t1 = 0;
                        continue L0;
                }
                break;
            }
            return c;
        }
        static r(a) {
            return stringFormat("{0}px", a);
        }
        static q(a) {
            return stringFormat("{0}px", a);
        }
        ak(a, b, c) {
            let d = this.j(a, b);
            let e = this.i(a, c);
            this.af(e, d);
            if (b == 2 || c == 2) {
                let f = 10;
                while (f > 0) {
                    let g = this.j(a, b);
                    let h = this.i(a, c);
                    if (g == d && h == e) {
                        f = 0;
                        break;
                    }
                    d = g;
                    e = h;
                    this.af(e, d);
                    f--;
                }
            }
            return new Rect(0, e, d, this.am.width, this.am.height);
        }
        z() {
            if (this.f) {
                this.n.setStyleProperty("width", stringEmpty());
                this.n.setStyleProperty("height", stringEmpty());
                this.al = new Size(1, this.m.outerWidth(), this.m.outerHeight());
                this.e = false;
                this.ag();
            }
            else {
                this.e = true;
            }
        }
        af(a, b) {
            let c = stringFormat("{0}px", a);
            let d = stringFormat("{0}px", b);
            this.n.setStyleProperty("left", c);
            this.n.setStyleProperty("top", d);
        }
        ac(a) {
            if (a == null) {
                this.k = null;
                return;
            }
            this.k = a;
            let b = a.rootWrapper;
            this.x(b);
            this.k.getPortal(this.m, "ChildContent", (c) => {
                let comp_ = c.componentRef;
                this.p = comp_;
            }, true);
        }
        ag() {
            let a = new Size(1, this.am.width, this.am.height);
            if (!this.f || !this.d.t) {
                a.height = 0;
            }
            let b = a.width;
            let c = a.height;
            if (this.c.r()) {
                if (this.h == c) {
                    return;
                }
                this.c.an();
                this.g = true;
                return;
            }
            this.g = false;
            let d = stringFormat("{0}px", b);
            let e = stringFormat("{0}px", c);
            this.n.setStyleProperty("width", d);
            this.n.setStyleProperty("height", e);
        }
        x(a) {
            this.o = a;
            this.ab();
        }
        y(a) {
            this.c = a;
        }
        aa() {
        }
        ad() {
            this.s();
            if (this.d.t) {
                return;
            }
            this.ag();
        }
    }
    PopupView.$t = /*@__PURE__*/ markType(PopupView, 'PopupView');
    return PopupView;
})();
/**
 * @hidden
 */
let Popup = /*@__PURE__*/ (() => {
    class Popup extends Base {
        constructor() {
            super();
            this.i = 0;
            this.h = 0;
            this.bc = null;
            this.n = null;
            this.o = null;
            this.onClosed = null;
            this.onPopup = null;
            this.propertyChanged = null;
            this.k = null;
            this.x = 50;
            this.p = true;
            this.v = -1;
            this.u = Popup.z;
            this.s = false;
            this.a3 = Popup.bb;
            this.a2 = Popup.ba;
            this.a1 = Popup.a9;
            this.a4 = null;
            let a = this.j();
            this.k = a;
            a.y(this);
        }
        au(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.aw(a, b, c);
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.au("AnimationDuration", b, a);
            }
        }
        get q() {
            return this.p;
        }
        set q(a) {
            let b = this.p;
            this.p = a;
            if (b != this.p) {
                this.au("AnimationEnabled", b, a);
            }
        }
        get aa() {
            return this.v;
        }
        set aa(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.au("Elevation", b, a);
            }
        }
        get w() {
            return this.u;
        }
        set w(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.au("ActualElevation", b, a);
            }
        }
        get t() {
            return this.s;
        }
        get a7() {
            return this.a3;
        }
        set a7(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.au("ActualUmbraShadowColor", b, a);
            }
        }
        get a6() {
            return this.a2;
        }
        set a6(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.au("ActualPenumbraShadowColor", b, a);
            }
        }
        get a5() {
            return this.a1;
        }
        set a5(a) {
            let b = this.a1;
            this.a1 = a;
            if (b != this.a1) {
                this.au("ActualAmbientShadowColor", b, a);
            }
        }
        get a8() {
            return this.a4;
        }
        set a8(a) {
            let b = this.a4;
            this.a4 = a;
            if (b != this.a4) {
                this.au("Background", b, this.a4);
            }
        }
        j() {
            return new PopupView();
        }
        aw(a, b, c) {
            switch (a) {
                case "IsShown":
                    if (false == this.t) {
                        this.k.ae();
                    }
                    break;
                case "Elevation":
                    this.w = this.aa == -1 ? Popup.z : this.aa;
                    break;
                case "ActualElevation":
                case "ActualUmbraShadowColor":
                case "ActualPenumbraShadowColor":
                case "ActualAmbientShadowColor":
                case "Background":
                    this.k.aj();
                    break;
                case "AnimationEnabled":
                    if (false == this.q) {
                        this.an();
                    }
                    break;
            }
        }
        an() {
            if (this.r()) {
                if (null != this.o && this.o.playState == 1) {
                    this.o.cancel();
                }
                if (null != this.n && this.n.playState == 1) {
                    this.n.cancel();
                }
            }
        }
        l(a) {
            let b = this.f(a);
            let c = a ? this.b() : this.a();
            let d = this.k.a(c);
            let e = new List$1(AnimationKeyFrameProperty.$, 0);
            let f = new List$1(AnimationKeyFrameProperty.$, 0);
            let g = new TranslateTransform();
            g.k = b.a;
            let h = new TranslateTransform();
            h.k = b.b;
            let i = new AnimationKeyFrameProperty(14, g);
            let j = new AnimationKeyFrameProperty(14, h);
            e.add(i);
            f.add(j);
            d.m(...e.toArray());
            d.m(...f.toArray());
            return KeyFrameAnimationFactory.f.c(d);
        }
        m(a) {
            let b = this.g(a);
            this.k.u(b.d);
            let c = a ? this.b() : this.a();
            let d = this.k.b(c);
            let e = new List$1(AnimationKeyFrameProperty.$, 0);
            let f = new List$1(AnimationKeyFrameProperty.$, 0);
            let g = new AnimationKeyFrameProperty(10, b.c);
            let h = new AnimationKeyFrameProperty(10, b.d);
            e.add(g);
            f.add(h);
            if (this.i == 2) {
                let i = b.a;
                let j = b.b;
                let k = new AnimationKeyFrameProperty(12, i);
                let l = new AnimationKeyFrameProperty(12, j);
                e.add(k);
                f.add(l);
            }
            d.m(...e.toArray());
            d.m(...f.toArray());
            return KeyFrameAnimationFactory.f.c(d);
        }
        a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.y;
            a.b = 3;
            return a;
        }
        b() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.y;
            a.b = 3;
            return a;
        }
        aq() {
            this.k.w();
        }
        f(a) {
            let b = truncate(this.k.am.height);
            if (b <= 0) {
                b = 500;
            }
            let c = a ? -b : 0;
            let d = a ? 0 : -b;
            if (this.i == 2) {
                c = 0;
                d = 0;
            }
            let e = ((() => {
                let $ret = new Popup_InnerAnimationInfo();
                $ret.a = c;
                $ret.b = d;
                return $ret;
            })());
            return e;
        }
        g(a) {
            let b = truncate(this.k.am.height);
            if (b <= 0) {
                b = 500;
            }
            let c = a ? 0 : b;
            let d = a ? b : 0;
            let e;
            let f;
            if (this.i == 2) {
                e = a ? this.bc.bottom : this.bc.top;
                f = a ? this.bc.top : this.bc.bottom;
            }
            else {
                e = this.bc.top;
                f = this.bc.top;
            }
            let g = ((() => {
                let $ret = new Popup_OuterAnimationInfo();
                $ret.c = c;
                $ret.d = d;
                $ret.a = e;
                $ret.b = f;
                return $ret;
            })());
            return g;
        }
        r() {
            if (null == this.o && null == this.n) {
                return false;
            }
            if (null != this.o && this.o.playState == 1) {
                return true;
            }
            if (null != this.n && this.n.playState == 1) {
                return true;
            }
            return false;
        }
        ar() {
            this.k.z();
        }
        av(a, b, c) {
            this.k.ad();
            this.bc = this.k.ak(a, b, c);
            this.i = b;
            this.h = c;
        }
        ay(a, b, c) {
            if (this.s) {
                this.s = false;
                this.au("IsShown", true, this.s);
            }
            this.av(a, b, c);
            this.az(true);
        }
        az(a) {
            this.an();
            let b = this.s;
            this.s = a;
            let c = this.g(a);
            let d = this.f(a);
            if (false == this.q) {
                let e = this.k.t(c, d);
                c = e.p0;
                d = e.p1;
                return;
            }
            this.aq();
            this.n = this.l(this.s);
            this.o = this.m(this.s);
            this.n.play();
            this.o.play();
            this.n.finished.f((f) => this.n.commitStyles());
            this.o.finished.f((f) => {
                this.o.commitStyles();
                this.au("IsShown", b, this.s);
                if (this.s) {
                    if (this.onPopup != null) {
                        this.onPopup(this, new OnPopupEventArgs());
                    }
                }
                else {
                    if (this.onClosed != null) {
                        this.onClosed(this, new OnClosedEventArgs());
                    }
                }
                let g = this.k.t(c, d);
                c = g.p0;
                d = g.p1;
            });
        }
        appendPopupContent(a) {
            this.k.v(a);
        }
        ao() {
            if (!this.s) {
                return;
            }
            this.az(false);
        }
        destroy() {
            this.provideRenderer(null);
        }
        showRelativeToExclusionRect(a, b, c) {
            this.ay(a, b, c);
        }
        as(a) {
            this.bc = this.k.ak(a, this.i, this.h);
        }
        notifySizeChanged() {
        }
        provideRenderer(a) {
            this.k.ac(a);
        }
        ab() {
            return this.c();
        }
        ak() {
            let a = this.c();
            return a.f();
        }
        c() {
            let a = new PopupVisualModelExport();
            a.e = this.w;
            a.d = this.t;
            a.c = AppearanceHelper.a(this.a7);
            a.b = AppearanceHelper.a(this.a6);
            a.a = AppearanceHelper.a(this.a5);
            return a;
        }
    }
    Popup.$t = /*@__PURE__*/ markType(Popup, 'Popup', Base.$, [INotifyPropertyChanged_$type]);
    Popup.z = 2;
    Popup.bb = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Popup.ba = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Popup.a9 = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    return Popup;
})();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgrOnPopupEventArgs {
    createImplementation() {
        return new OnPopupEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
}

class IgrOnClosedEventArgs {
    createImplementation() {
        return new OnClosedEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
}

class IgrPopup extends Component {
    constructor(props) {
        super(props);
        this._reactRenderer = null;
        this._implementation = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._onClosed = null;
        this._onClosed_wrapped = null;
        this._onPopup = null;
        this._onPopup_wrapped = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._getMainRef = this._getMainRef.bind(this);
        if (props) {
            this.initializeProperties();
        }
        this._initialized = true;
    }
    set height(value) {
        this._height = value;
        if (this._elRef) {
            this._elRef.style.height = value;
            this.i.notifySizeChanged();
        }
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        if (this._elRef) {
            this._elRef.style.height = value;
            this.i.notifySizeChanged();
        }
    }
    get width() {
        return this._width;
    }
    _getMainRef(ref) {
        this._elRef = ref;
        this.verifyReferences();
    }
    verifyReferences() {
        if (this._elRef) {
            this.requestRender = this.requestRender.bind(this);
            this._portalManager = new PortalManager("popupContent", this.requestRender);
            this._reactRenderer = new ReactRenderer(this._elRef, document, true, {}, this._portalManager);
            // render needs to fire again after the portalManager is created. 
            this.requestRender();
            this.i.provideRenderer(this._reactRenderer);
        }
    }
    render() {
        let propChildren = this.props.children;
        let children = [];
        Children.forEach(propChildren, (ch) => {
            children.push(cloneElement(ch));
        });
        if (this._portalManager)
            this._portalManager.onRender(children);
        let div = createElement("div", {
            ref: this._getMainRef,
            children: children
        });
        return div;
    }
    requestRender() {
        if (this._initialized)
            this.setState({});
    }
    shouldComponentUpdate(nextProps, nextState) {
        const mod = getModifiedProps(this.props, nextProps);
        for (const p of Object.keys(mod)) {
            if (isValidProp(this, p)) {
                this[p] = mod[p];
            }
        }
        return true;
    }
    initializeProperties() {
        for (const p of Object.keys(this.props)) {
            if (isValidProp(this, p)) {
                this[p] = this.props[p];
            }
        }
    }
    // supports angular themes or custom properties set in CSS
    updateStyle() {
        this._styling(this._elRef, this);
    }
    componentWillUnmount() {
        this.i.destroy();
        if (this._reactRenderer)
            this._reactRenderer.destroy();
    }
    componentDidMount() {
        this._elRef.style.width = this._width ? this._width : "";
        this._elRef.style.height = this._height ? this._height : "";
        this.initializeContent();
    }
    initializeContent() {
        this._styling(this._elRef, this);
        this.updateStyle();
    }
    createImplementation() {
        return new Popup();
    }
    get i() {
        return this._implementation;
    }
    /**
 * Gets or sets the duration of the Popup and Closeup animations in milliseconds.
*/
    get animationDuration() {
        return this.i.y;
    }
    set animationDuration(v) {
        this.i.y = +v;
    }
    /**
     * Gets or sets whether the popup and closeup animations are animated.
    */
    get animationEnabled() {
        return this.i.q;
    }
    set animationEnabled(v) {
        this.i.q = ensureBool(v);
    }
    /**
     * Gets or sets the elevation to use for the button regardless of type.
    */
    get elevation() {
        return this.i.aa;
    }
    set elevation(v) {
        this.i.aa = +v;
    }
    /**
     * Gets or sets the elevation of the border shadow
    */
    get actualElevation() {
        return this.i.w;
    }
    set actualElevation(v) {
        this.i.w = +v;
    }
    /**
     * Gets / sets the isShown state of the panel.
    */
    get isShown() {
        return this.i.t;
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualUmbraShadowColor() {
        return brushToString(this.i.a7);
    }
    set actualUmbraShadowColor(v) {
        this.i.a7 = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualPenumbraShadowColor() {
        return brushToString(this.i.a6);
    }
    set actualPenumbraShadowColor(v) {
        this.i.a6 = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the check mark when the checkbox is checked.
    */
    get actualAmbientShadowColor() {
        return brushToString(this.i.a5);
    }
    set actualAmbientShadowColor(v) {
        this.i.a5 = stringToBrush(v);
    }
    /**
     * Gets or sets the background color of the popup.
    */
    get background() {
        return brushToString(this.i.a8);
    }
    set background(v) {
        this.i.a8 = stringToBrush(v);
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("Popup");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Closes the popup.

*/
    close() {
        this.i.ao();
    }
    showRelativeToExclusionRect(exclusionRect, popupDirection, popupAlignment) {
        this.i.showRelativeToExclusionRect(toRect(exclusionRect), (popupDirection == null ? null : popupDirection), (popupAlignment == null ? null : popupAlignment));
    }
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel() {
        let iv = this.i.ab();
        return (iv);
    }
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel() {
        let iv = this.i.ak();
        return (iv);
    }
    get onClosed() {
        return this._onClosed;
    }
    set onClosed(ev) {
        if (this._onClosed_wrapped !== null) {
            this.i.onClosed = delegateRemove(this.i.onClosed, this._onClosed_wrapped);
            this._onClosed_wrapped = null;
            this._onClosed = null;
        }
        this._onClosed = ev;
        this._onClosed_wrapped = (o, e) => {
            let outerArgs = new IgrOnClosedEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeOnClosed) {
                this.beforeOnClosed(this, outerArgs);
            }
            if (this._onClosed) {
                this._onClosed(this, outerArgs);
            }
        };
        this.i.onClosed = delegateCombine(this.i.onClosed, this._onClosed_wrapped);
    }
    /**
     * Fires when the popup is shown
    */
    get onPopup() {
        return this._onPopup;
    }
    set onPopup(ev) {
        if (this._onPopup_wrapped !== null) {
            this.i.onPopup = delegateRemove(this.i.onPopup, this._onPopup_wrapped);
            this._onPopup_wrapped = null;
            this._onPopup = null;
        }
        this._onPopup = ev;
        this._onPopup_wrapped = (o, e) => {
            let outerArgs = new IgrOnPopupEventArgs();
            outerArgs._provideImplementation(e);
            if (this.beforeOnPopup) {
                this.beforeOnPopup(this, outerArgs);
            }
            if (this._onPopup) {
                this._onPopup(this, outerArgs);
            }
        };
        this.i.onPopup = delegateCombine(this.i.onPopup, this._onPopup_wrapped);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
class IgrPopupModule {
    static register() {
        IgrChildContentModule.register();
        TypeRegistrar.registerCons('IgrPopup', IgrPopup);
        TypeRegistrar.registerCons('IgrPopup', IgrPopup);
        TypeRegistrar.register('Popup', Popup.$type);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates which side of the exclusion rectangle to which the popup is aligned.
 */
var PopupAlignment = /*@__PURE__*/ (function (PopupAlignment) {
    /**
     * No specified direction.
     */
    PopupAlignment[PopupAlignment["Auto"] = 0] = "Auto";
    /**
     * Popup should be aligned to the near side. This usually means left or top.
     */
    PopupAlignment[PopupAlignment["Near"] = 1] = "Near";
    /**
     * Popup should be aligned to the near far. This usually means right or bottom.
     */
    PopupAlignment[PopupAlignment["Far"] = 2] = "Far";
    return PopupAlignment;
})({});
/**
 * @hidden
 */
let PopupAlignment_$type = /*@__PURE__*/ markEnum('PopupAlignment', 'Auto,0|Near,1|Far,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Indicates which direction the popup will pop up in relation to the exclusion rectangle.
 */
var PopupDirection = /*@__PURE__*/ (function (PopupDirection) {
    /**
     * No specified direction.
     */
    PopupDirection[PopupDirection["Auto"] = 0] = "Auto";
    /**
     * Popup should be displayed downward.
     */
    PopupDirection[PopupDirection["Down"] = 1] = "Down";
    /**
     * Popup should be displayed downward.
     */
    PopupDirection[PopupDirection["Up"] = 2] = "Up";
    return PopupDirection;
})({});
/**
 * @hidden
 */
let PopupDirection_$type = /*@__PURE__*/ markEnum('PopupDirection', 'Auto,0|Down,1|Up,2');

export { ExpansionPanel, ExpansionPanelUtilities, ExpansionPanelView, IgrExpansionPanel, IgrExpansionPanelModule, IgrOnClosedEventArgs, IgrOnCollapsedEventArgs, IgrOnExpandedEventArgs, IgrOnPopupEventArgs, IgrPopup, IgrPopupModule, OnClosedEventArgs, OnCollapsedEventArgs, OnExpandedEventArgs, OnPopupEventArgs, Popup, PopupAlignment, PopupAlignment_$type, PopupDirection, PopupDirection_$type, PopupView, PopupVisualModelExport, Popup_InnerAnimationInfo, Popup_OuterAnimationInfo };
//# sourceMappingURL=igniteui-react-layouts.js.map
